<template>
<div>
        <p v-if="loading">loading...</p>
        <div v-else>
            <div>
                <input type="text" v-model="tags">
            </div>
            <div  class="photo-gallery">
                <div v-for="photo in photos"
                     :key="photo.id"
                     @click="selectedItem = photo; $emit('item-selection', photo)"
                     class="photo-gallery-item"
                     v-bind:class="[photo === selectedItem ? 'photo-gallery-item--selected': '']">
                    <img v-bind:src="photo.url" class="photo-gallery-item__picture">
                </div>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import _ from 'lodash';
import Photo from '../model/Photo';
import FlickrService from '../services/flickr-service'
const flickrService = new FlickrService();

export default Vue.extend({
    name: "GalleryList",
        data: function() {
        return {
            loading:true,
            photos: [],
            tags: '',
            selectedItem: null
        }
    },
    watch: {
        tags: function() {
            this.updatesearch();
        },
        selectedItem: function() {
            console.log(this.selectedItem);
        } 
    },
    methods: {
        updatesearch: _.debounce(function()  {
            console.log(this.tags);
            console.log("#### UPDATE SEARCH")
            flickrService.search(this.tags)
                     .then(photos => {
                         this.loading = false;
                         this.photos = photos.map(photo => {
                             photo.url = flickrService.getPhotoUrl(photo);
                             return photo;
                        });
                        console.log(this.photos);
                     });    
        }, 500)
    },
    created() {
        this.updatesearch();        
    },
})
</script>

<style scoped>
    .photo-gallery {
        display: grid;
        grid-template-columns: 1fr 1fr 1fr;
        grid-gap: 10px;
    }

    .photo-gallery-item {

    }


    .photo-gallery-item--selected {
        border: 2px solid red;
    }


    .photo-gallery-item__picture {
        display: block;
        width: 100%;
        /* max-height: 200px; */
    }
</style>

